#!/bin/bash
#
# include:
# include/cursor_tools.inc
#---------------------------

#-------------
function c_pos
#-------------
{
    local CURPOS
    read -sdR -p $'\E[6n' CURPOS
    CURPOS=${CURPOS#*[} # Strip decoration characters <ESC>[
    echo "${CURPOS}"    # Return position in "row;col" format
}

#-------------
function c_row
#-------------
{
    local COL
    local ROW
    IFS=';' read -sdR -p $'\E[6n' ROW COL
    echo "${ROW#*[}"
}

#-------------
function c_col
#-------------
{
    local COL
    local ROW
    IFS=';' read -sdR -p $'\E[6n' ROW COL
    echo "${COL}"
}

#-----------
cursor_off()
#-----------
{
    tput civis  
}

#----------
cursor_on()
#----------
{
    tput cnorm
}