#!/bin/bash
#
# include:
# key_tools.inc
#
# check_key() 
# get_key()
# 
# ---------------------------------


#----------
ctrl_c_on()
#----------
{
    trap 'exit' 2  
}

#-----------
ctrl_c_off()
#-----------
{
    trap '' 2  
}

#----------
check_key()
#----------
{
 local key=$KEY_BUFFER

 case "$key" in

 $'\x7f')  # Backspace
           #exit
           return 8
           ;;
    

 $'\x08') # ctrl/strg-h
           return 9
           ;;

 $'\x1b\x5b\x32\x7e')  # Insert
                       #echo Insert Key
                       return 48
                       ;;
 $'\x1b\x5b\x33\x7e')  # Del
                       #echo Insert Key
                       return 49
                       ;;

 #$'\x1b\x5b\x34\x7e')  # End_key_num_1
 #$'\x1b\x5b\x4F\x46')  # End_key_num_1
                 $'°')
                       return 34
                       ;;                      

  $'\x1b\x5b\x41')  # Up_arrow / oben
                    #echo Up arrow
                    return 41
                    ;;
  $'\x1b\x5b\x42')  # Down_arrow / unten
                    #echo Down arrow
                    return 42
                    ;;
  $'\x1b\x5b\x43')  # Right_arrow
                    #echo Right arrow
                    return 43
                    ;;
  $'\x1b\x5b\x44')  # Left_arrow
                    #echo Left arrow
                    return 44
                    ;;

  #$'\x1b[H') # POS1  
  #          return 9
  #          ;;

  $'\x0a')  # Enter
            #echo Enter Key
            return 13
            ;;

  $'\x20')  # Space
            #echo "Space Key"
            return 20
            ;;
  $'\x09')  # Tab
            #echo TAB
            return 99
            ;;
  $'\x1b')  # Escape
            return 27
             ;;
 esac
 return 0
}

#--------
get_key()
#--------
{
   local return_value

   KEY_BUFFER=""
   unset K1 K2 K3
   # -sn1
   read -s -N1 -p ''
   K1="$REPLY"
   read -s -N2 -t 0.003
   K2="$REPLY"
   read -s -N1 -t 0.003
   K3="$REPLY"
   KEY_BUFFER="$K1$K2$K3"

   check_key
   return_value=$?
   case "$return_value" in
		 0) # Normal Keys
            return 0
            ;;

         8) # Backspace
            return 8
            break
            ;;
         9) return 9
            break 
            ;;
        27) #ESC
            return 27
            break
            ;;
	    13) # Return
	        return 13
            break
            ;;
        20) # Space
            KEY_BUFFER=$LEER_CHAR    # $'\x20' #$LEER_CHAR
            return 0
            ;;
        34) # END    
            return 34
            ;;
        41) # Up_arrow / oben
            return 41
            break
            ;;
        42) # down_arrow / unten
            return 42
            break
            ;;            
        43) # Right
            #KEY_BUFFER=$LEER_CHAR
            return 43
            #return 0
            break
            ;;
        44) # Left
            return 44
            break
            ;;
        48) # Insert
            #KEY_BUFFER=$LEER_CHAR
            return 48
            break
            ;;
        49) # Delet
            #KEY_BUFFER=$LEER_CHAR
            return 49
            break
            ;;
		99) # Muellkorb Keys
            return 99
            break
            ;;
   esac

}
