#!/bin/bash
#
# include:
# include_functions/string_tools.inc
# 
# ---------------------------------


#---------------
korriere_value()
#---------------
{
	local co_value=$1   # maskenbreite
	local _file=$2 		# wo,welche Datei
	local _variable=$3 	# variable, die veraendert werden soll

  
  	#echo "_variable$co_value"/"_variable$((co_value+1))"
	sed s/"$_variable$co_value"/"$_variable$((co_value+1))"/g $_file > $_file.tmp
	cp "$_file.tmp" "$_file"
	sleep 0.25
	rm "$_file.tmp"
	echo $((co_value+1))
}

#---------------
zentriere_text()
#---------------
{
	# Achtung bei $w mit modulo 1 , wird immer der Restwert von $m verwertet! $w>0 
	local _txt=$1
	local laenge_txt=${#_txt}
	local masken_breite=$2
	local m=0
	local w=0



	if [ $(( masken_breite % 2 )) != 0 ]
	then	
		masken_breite=$(korriere_value $2 "$(pwd)/const/fix_change_variable" "local screen_mask_breite=")
	fi	
	m=$(($(($masken_breite - $laenge_txt)) / 2 ))
	w=$(($(($masken_breite - $laenge_txt)) % 2 )) 
  	echo $(($m + $screen_mask_pos_x))

}

#-----------------
mark_input_field()
#-----------------
{
	local lg=$1
	local use_char=$2
	local field=""
	local i=0

	if [[ -z $lg ]] 
	then
		lg=24
	fi	
	if [[ -z $use_char ]] 
	then
		use_char=$BLANK      #"\\$(printf '%03o' "32")"
	fi		

	for (( i=1;i < $lg; i++ ))
	do
		field=$field$use_char
	done
	#printf ">"$use_char"<"
	echo $field	
}

#-----------------
show_input_field()
#-----------------
{
	local field=$1
	local lg=$2
	local use_char="░"
	local i=0

	if [[ -z $lg ]] 
	then
		lg=24
	fi
	i=${#field}
	for (( i;i < $lg; i++ ))
	do
		field=$field$use_char
	done 
	echo $field

}

#----------------------
find_prae_post_string()
#----------------------
{
	local examined_str=$1
	local cut_str=$2 		# "_" default
	local char=""
	local post_prae=$3		# po=post;pr=prae;bo=both
	local lg=0
	local anz=1
	local return_value=""

 
	if [[ -z "$cut_str" ]]
	then
		cut_str="_"
	fi	

	if [[ -z "$post_prae" ]]
	then
		post_prae="pr"
	fi	

	lg=${#examined_str}

	for(( anz=1; anz <= $lg; anz++ ))
	do
		char="${examined_str:$((lg-anz)):1}"
		if [[ "$char" == "$cut_str" ]]
		then
			break
		fi	
	done	

    case $post_prae in 
    	    "pr") return_value=${examined_str:0:$((_lg-anz+1)) }
				  ;;
			"po") return_value=${examined_str:$((_lg-anz+1)):$lg }
				  ;;
			"bo") return_value="noch nicht implementiert!"
				  ;;
			   *) return_value="Vergesslichkeit"
    esac
	echo $return_value

}

#------------------------
loesche_char_in_string()
#------------------------
{
	local str=$1
	local pos=$2
	local act_lg=0
	local i=0
	local tmp_str=""
	local return_value=""

	act_lg=${#str}
	tmp_str=${str:0:$((pos-1))}${str:$((pos)):$act_lg}
	return_value=$tmp_str
	echo $return_value
}

#----------------------
insert_char_in_string()
#----------------------
{
	local str=$1
	local pos=$2   #$(($2 - 1))
	local absolut_lg=$3
	local char="_"
	local act_lg=0
	local lg=0
	local tmp_str=""
	local return_value=""

	#if (( $pos >= 2 ))
	#then
	#	pos=$((pos -1 ))
	#fi	
	
	act_lg=$((${#str}))
	
	#tmp_str=${str:0:$((pos - 1))}$LEER_CHAR${str:$((pos - 1)):$act_lg}
	tmp_str=${str:0:$((pos))}$LEER_CHAR${str:$((pos)):$act_lg}
	lg=${#tmp_str}
	if (( $lg > $absolut_lg ))
	then	
		return_value=${tmp_str:0:$((lg-1))}
	else
		return_value=${tmp_str:0:$((lg))}
	fi
	echo $return_value
}
