#!/bin/bash
#
# include:
# include_functions/mask_edit.inc
# 
# ---------------------------------

. const/fix_change_mask_variable
. include_functions/file_tools.inc
. include_functions/tools.inc



#---------------
char_typ_check()
#---------------
{
	local check_key_pressed=$1
	local value_typ=$2			# n=numerisch, l=letter,buchstabel, a=alphanumerisch, 'n' und 'l' und Sonderzeichen 'cb'=checkbox
	local return_value=1

	if [[ $value_typ = "al" ]]
	then
		#echo "alphanummerisch"
		case $check_key_pressed in
			#[a-zA-Z] ) return_value=0 ;;
			#   [0-9] ) return_value=0 ;;
			#  [+-.,_] ) return_value=0 ;;	
	   [+-.,\;\?_]|[0-9]|[a-zA-Z] ) return_value=0 ;;
		esac
	fi
	if [[ $value_typ = "num" ]]
	then
		#echo "Typ: Zahl : "$check_key_pressed
		case $check_key_pressed in
			 [0-9] ) return_value=0 ;;
			[+-.,] ) return_value=0 ;;		
		esac
	fi	
	if [[ $value_typ = "let" ]]
	then
		#echo "Typ: Buchstaben"
		case $check_key_pressed in
	         [+-.,\;\ ] ) return_value=0 ;;	
			  [aA-zZ] ) return_value=0 ;;	
			     [?!] ) return_value=0 ;;
			#     [ ] ) return_value=0 ;;
		esac
	fi	
	if [[ $value_typ = "cb" ]]
	then
		#echo "Typ: chechbox"
		case $check_key_pressed in
			  [*] ) return_value=0 ;;

		esac
	fi	

	echo $return_value

}

#--------------------------
input_field_to_bufferfile()
#--------------------------
{
	local z_nr=$1
	local data_field=$2
	local screen_nr=$3
	local anz_input_rows=$4
	local from_file=$5
	local search_obj=""
	local temp=""

	search_obj="field_"$z_nr'='

	temp=$(grep $search_obj $from_file)
	temp=${temp#field_*=\"}   	# Abschneiden " field_*=\n "
	temp=${temp%\"*}		 	# Ende " \" " abschneiden

	echo $temp$data_field >> "$f_data_02"


}

#-------------------------
currently_netz_parameter()
#-------------------------
{
	
		local _search_value=$1
		local _action=$2     		# r=read, w=write
		local _file=$f_data_02       # "$(pwd)/var/network_config.dat"
		local temp=""
		local lg=""
		local return_value

		temp=`grep $_search_value $_file`
		#echo $temp
		lg=${#temp}
		#echo $lg
		temp=${temp:7:((lg-8))}
		temp=${temp%%"\""} 				# loescht doppelte Anfuehrungsstriche " am Ende des String
		return_value=$temp
		echo $return_value
		
}

#------------
input_field()
#------------
{

	. const/fix_change_mask_variable
	. include_functions/checkbox.inc

	#------------------------------------
	#local screen_mask_breite=58
	#local screen_mask_laenge=20
	#local screen_mask_pos_x=8   	# Spalte=x  Zeile=y
	#local screen_mask_pos_y=2   	# Zeile=y

	#local masken_header_pos_x=4	# Spalte=x , header wird zentriert ausgegeben
	#local masken_header_pos_y=4		# Zeile=y

	#local masken_text_pos_x=$((screen_mask_pos_x + 4 ))	# Spalte=x
	#local masken_text_pos_y=6		# Zeile=y

	#------------------------------------
	local z_nr=$1
	local z_lg=$2
	local z_typ=$3
	local screen_nr=$4
	local anz_input_rows=$5
	local input_char=""
	local input_field_buffer=""
	local counter_field_char=0
	local input_buffer=""
	local steuerung=0
	local abbruch_regulaer=0  # 1=Ja 0=Nein
	local saved_data=false
	local build_config_file=false
	local _file=$f_data_03                     #"$(pwd)/kassenlog/input.data" #
	local _file_1=$f_data_01                   #"var/network_config_parameter_variable"
	local lg=0
	local _str=""
	

	input_buffer=${global_array[$z_nr]}
	lg=${#input_buffer}

	_str=${mask_text_array[0,$z_nr]}

	for ((counter_field_char=1;counter_field_char <= $((z_lg + 1)); counter_field_char++))
	do
		z_rt=$z_nr # globale variable aktuelle Zeile!
		
		lg=$counter_field_char
		pos_x_y $(($masken_text_pos_y + $z_nr)) $(($masken_text_pos_x+${#_str}+1+$counter_field_char))
		if [[ "$z_typ" == "cb" ]] # spezielle anpassung an darstellung '[ ]'
		then
		  pos_x_y $(($masken_text_pos_y + $z_nr)) $(($masken_text_pos_x+${#_str}+2+$counter_field_char))
		fi	
		get_key
		key_pressed=$?	
		if (( $key_pressed != 0 )) 
		then
			steuerung=$key_pressed
			case "$steuerung" in

							 8 ) 	if (( $counter_field_char <= 1 )) 
									then
										saved_data=false
										counter_field_char=$((counter_field_char - 1))
									else	
								 	    abbruch_regulaer=0   # Backspace
									    goto_xy_write $(($masken_text_pos_y + $z_nr)) $(($masken_text_pos_x+${#_str}+2)) $(mark_input_field $z_lg $LEER_CHAR)
									    input_buffer=${input_buffer:0:$((lg-1))}
									    counter_field_char=$((counter_field_char - 2))
									fi
								 
								 ;;
							  9) abbruch_regulaer=99  
								 # hier links Oben -> [99]
								 mask_draw "99" "Online Hilfe für KssEH" "Version 1.0 " # format: Parameter_1=Bildschirm-Nr, Parameter_2=Bildschirm-Text-1, Parameter_3=Bildschirm-Text_2
							   	 mask_draw "" "" "" $abbruch_regulaer
							   	 abbruch_maske=true

							   	 ;;		 
							27 ) abbruch_regulaer=27 	# ESC
								 abbruch_maske=true 
								 ;;

							13 ) abbruch_regulaer=13    # ENTER/RETURN
								 ;;

							34 ) abbruch_regulaer=0 	# END über Sonderzeichen [SHIFT]+°
								 counter_field_char=$((z_lg-1)) 
								 ;; 

							41 ) abbruch_regulaer=41    # oben
								 if ((z_rt > 1))
								 then
								 	z_rt=$((z_rt - 2))
								 fi		
								 ;;

							42 ) abbruch_regulaer=42    # unten
								 ;;

							43 ) abbruch_regulaer=0    # Cursor rechts
								 # automatisch hochgezählt! counter_field_char+1
								 ;;	

							44 ) abbruch_regulaer=0    # Cursor links
								 if ((  $((counter_field_char - 2 )) >= 0 )) 
								 then
								 	counter_field_char=$((counter_field_char - 2 ))
								 else	
								 	counter_field_char=$((counter_field_char - 1 ))

								 fi	
								 ;;	
							48 ) abbruch_regulaer=0    # Insert
								 input_buffer=$(insert_char_in_string $input_buffer $counter_field_char $z_lg)
								
								 ;;	 
							49 ) abbruch_regulaer=0    # Del
								 input_buffer=$(loesche_char_in_string $input_buffer $counter_field_char) 
								 goto_xy_write $(($masken_text_pos_y + $z_nr)) $(($masken_text_pos_x+${#_str}+2)) $(mark_input_field $z_lg $LEER_CHAR)	
								 counter_field_char=$((counter_field_char - 1 ))
								 ;;	 

										 								 
			esac	
										

		else	
			# erlaubte Zeichen mit == 0!
			if (( $( char_typ_check $KEY_BUFFER $z_typ ) == 0 ))
			then
				input_buffer=${input_buffer:0:$((counter_field_char-1))}$KEY_BUFFER${input_buffer:$((counter_field_char)):${#input_buffer}}
			else
				if [[ "$z_typ" == "cb" ]]
				then
					check_box  $(($masken_text_pos_y + $z_nr)) $(($masken_text_pos_x+${#_str}+2)) $z_rt "*" 
					input_buffer=${input_buffer:0:$((counter_field_char-1))}$KEY_BUFFER #${input_buffer:$((counter_field_char)):${#input_buffer}}
				fi	
				counter_field_char=$(decrement $counter_field_char)	
			fi	

		fi	

		if [[ "$z_typ" != "cb" ]]
		then	
			goto_xy_write $(($masken_text_pos_y + $z_nr)) $(($masken_text_pos_x+${#_str}+2)) $(mark_input_field $z_lg ' ')
			goto_xy_write  $(($masken_text_pos_y + $z_nr)) $(($masken_text_pos_x+${#_str}+1)) $input_buffer
		fi
		if (( $abbruch_regulaer != 0 )) #&& (( $abbruch_regulaer <= 42 ))
		then
			if (( $abbruch_regulaer == 13 )) || (( $abbruch_regulaer == 41 )) || (( $abbruch_regulaer == 42 )) 
			then	
				#if [ -n "$input_buffer" ] # verhindert das leere Eingabezeilen gespeichert werden!
				#then	
					global_array[$z_nr]=$input_buffer
					sed -i "$((${z_nr}+1))s/.*/$data_02_field$z_nr"="\"${input_buffer}\"/" $_file
					saved_data=true
				#fi
			fi	


			if (( $abbruch_regulaer == 27 ))
			then
				break
			fi	
			break
		fi	
		#------------------------------------- weil "counter_field_char" bei 1 anfängt und nicht mit 0
		
		if (( $counter_field_char == $z_lg ))
		then
			if [ -n "$input_buffer" ]
			then	
				global_array[$z_nr]=$input_buffer
				sed -i "$((${z_nr}+1))s/.*/$data_02_field$z_nr"="\"${input_buffer}\"/" $_file
				saved_data=true
			fi
			break
		fi		
	done

	if (( $abbruch_regulaer != 27 ))
	then
		if [[ "$saved_data" = false ]]
		then
			if [ -n "$input_buffer" ]
			then
			    global_array[$z_nr]=$input_buffer	
				sed -i "$((${z_nr}+1))s/.*/$data_02_field$z_nr"="\"${input_buffer}\"/" $_file
				saved_data=true
			fi
		fi	

		if [[ "$saved_data" = true ]]
		then	
			global_array[$z_nr]=$input_buffer
			#actual_bufferlaenge=$((actual_bufferlaenge + 1))
			input_field_to_bufferfile $z_nr "$input_buffer" $screen_nr $anz_input_rows "$_file_1"
		fi	
	fi
}

#----------
mask_edit()
#----------
{
	. const/fix_change_mask_variable
	. include_functions/string_tools.inc
	#. include_functions/cursor_tools.inc
	
	local screen_nr=$1
	local anz_rows=$2
	local zeilen_nr=1
	local input_buffer=""
	local laenge_text_feld=0
	local feld_typ="x"   # n=numerisch, l=letter,buchstabel, a=alphanumerisch, 'n' und 'l' und Sonderzeichen
	local counter=0
	local z=0
	local x=0
	local y=0
	local w=0
	local a=0
	local row_line=""
	local lg=0
	local return_value=0
	local exit_loop=false 
	local _str=""  
	local part_str=""
	local array_string_tmp=""

	   	  z_rt=0 		# global im gesamten script!!! die gerade aktuelle Zeile des input_field 
	      abbruch_maske=false
	
	
	#-----------------------------------------
	#goto_xy_write 30 5 $anz_rows
	# Einlesen der Werte zur Bearbeutung 

	if [ -f "$f_data_03" ]     #(pwd)/kassenlog/input.data"  #$(pwd)/var/network_config.dat" 
	then
			zeilen_nr=0
	  		while read row_line
	  		do
	  			if [[ "$row_line" != "[Mask-????]" ]]
	  			then	
	  				lg=${#row_line}
	  				
	  				if (( $zeilen_nr <= 9 ))
	  				then
	  					_str=${row_line:9:((lg-9))}
	  				else	
	  					_str=${row_line:10:((lg-10))}
	  				fi 	
	  				_str=${_str%%"\""} 
	  			fi
	  			xy=${#mask_text_array[0,$zeilen_nr]}
	  			goto_xy_write $(($masken_text_pos_y + $zeilen_nr)) $(($masken_text_pos_x + $xy + 1 )) $(mark_input_field $xy )
	  			goto_xy_write $(($masken_text_pos_y + $zeilen_nr)) $(($masken_text_pos_x + $xy + 1)) $_str
	  			global_array[$zeilen_nr]=$_str
	  			zeilen_nr=$(( zeilen_nr + 1 ))
	  		done < $f_data_03        #$(pwd)/kassenlog/input.data 

	  		zeilen_nr=1 # Variable auf Ausgangswert zurüchsetzen
		
	else
		# File not exist
		rm -f "$f_data_02"  #$(pwd)/var/network_config.dat"  #"$(pwd)/kassenlog/input.data" 
		#rm -f "$f_data_04"  # !!! test
	fi	
	
	#-----------------------------------------
	# Bearbeitung der Werte 
	if [[ -z $anz_rows ]]
	then
		w=$(rows_of_screen_nr $screen_nr)
		anz_rows=$w
	fi	

	if [[ -z $screen_nr ]]
	then
		screen_nr="1"
	fi	

	while [ !exit_loop ]
	do

		input_buffer=""
		for ((zeilen_nr; zeilen_nr <= $anz_rows; zeilen_nr++))
	  	do
	  		abbruch_maske=false
	  		z_tr=$zeilen_nr
	  		laenge_text_feld=${mask_text_length[1,$zeilen_nr]}

	  		feld_typ=${mask_text_typ_array[0,$zeilen_nr]}

  			input_field $zeilen_nr $laenge_text_feld $feld_typ $screen_nr $anz_rows
	
	  		if [[ $abbruch_maske = true  ]]
	  		then
	  			break
	  		fi	
	  		zeilen_nr=$z_rt
		done
		# Speicherung der Eingaben
		
		z=$(($NUMBER_OF_LINES_Screen_Frame + 2))
		x=$(zentriere_text "$mask_text_question" "$screen_mask_breite" )
		goto_xy_write $z $x "$mask_text_question [ ]" 
		y=${#mask_text_question}
		y=$((y + x + 3)) 
		desicion_answer j n $z $y "27"
		return_value=$?

		write_array_to_finished_file 
		if (( $return_value == 0 )) || (( $return_value == 27 ))
		then
			
			if (( $return_value == 27 ))
			then
				# lösche Datei /kasslog/input.data 
				rm -f "$f_data_02"     #"$(pwd)/var/network_config.dat"
				rm -f "$f_data_03"     #"$(pwd)/kassenlog/input.data" 
				#rm -f "$f_data_04"
				rm -f "$f_data_05"
			fi	
			#write_array_to_finished_file
			return $return_value
		fi
		
		zeilen_nr=1
	
	done
	
}