#!/bin/bash
#
# netz_install_netplan.inc


netplan_active()
{
	
	# Achtung: unbedingt apt install yamllint
	# yamllint 99-net-fix_ip_wan_wlan.yaml  -> zur Fehlersuche in *.yaml  !!!!!

	local art_netz=$1           # dhcp oder fix_ip
	local wan_card="enp"		# praeposition=enp
	local wlan_card="wlp"		# praeposition=wlp

	local _line=""
	local _lg=0
	local _i=0
	declare -a _array

	wlan_card=$(sudo lshw -C network 2>/dev/null | grep "wlp" )
	wan_card=$(sudo lshw -C network  2>/dev/null| grep "enp")
	#wlan_card=$(sudo lshw -C network | grep "wlp" )
	#wan_card=$(sudo lshw -C network  | grep "enp")
	

	wan_card=${wan_card##*: }
	wlan_card=${wlan_card##*: }
    
	if [[ $art_netz = "uncertain" ]]
	then 
		echo "uncertain"    #>> tmp.dat 
		exit
	fi 


	######################################################
    # array aufbau mit netz-informationen
    while read _line
    do
    	_lg=${#_line}
    	
    	for (( _i; $_i<$_lg; _i++ ))
    	do
    		if [[ "${_line:$_i:1}" == "=" ]]
    		then	
    			_found_value=${_line:$((_i+1)):$((_lg-_i))}
    			_array[$_index]="$_found_value"
    			_index=$((_index+1))
    		fi	
    	done	
    	_i=0
	done < $f_data_04 

	if [[ $art_netz = "dhcp" ]]
	then 
		#echo "DHCP"
		#echo "# LAN" > $f_data_06
		echo "---" > $f_data_06
		echo "network:" >> $f_data_06
		echo "#  renderer: networkd" >> $f_data_06
		echo "#  renderer: NetworkManager" >> $f_data_06
		echo "  version: 2" >> $f_data_06
		echo "#  ethernets:" >> $f_data_06
		echo "#    $wan_card:" >> $f_data_06
		echo "#     dhcp4: true" >> $f_data_06
		echo "#      dhcp6: false" >> $f_data_06
		echo "#      addresses: [192.168.0.232/24]" >> $f_data_06
		echo "#      gateway4: 192.168.0.250" >> $f_data_06
		echo "#      nameservers:" >> $f_data_06
		echo "#        addresses: [192.168.0.250, 8.8.8.8]" >> $f_data_06

		#echo "# WLAN" >> $f_data_06
		#echo "network:" >> $f_data_06
		#echo "  version: 2" >> $f_data_06
		echo "  renderer: networkd" >> $f_data_06
		echo "  wifis:" >> $f_data_06
		echo "    $wlan_card:" >> $f_data_06                    
		echo "      optional: true" >> $f_data_06
		echo "      access-points:" >> $f_data_06
		echo "        \"access-0124\":" >> $f_data_06									
		echo "          password: \"32015-0306.62v\"" >> $f_data_06	
		echo "      dhcp4: true" >> $f_data_06
		echo "      dhcp6: false" >> $f_data_06		
		echo "      gateway4: 192.168.0.250" >> $f_data_06	
		echo "      nameservers:" >> $f_data_06	
		echo "        addresses: [192.168.0.250, 8.8.8.8]" >> $f_data_06	
		
		
	fi 
	if [[ $art_netz = "fix_ip" ]]
	then 
		#echo "fix-ip"
		#echo "# LAN" > $f_data_07
		echo "---" > $f_data_07
		echo "network:" >> $f_data_07
		echo "  version: 2" >> $f_data_07
		#echo "  renderer: NetworkManager" >> $f_data_07
		echo "  renderer: netplan" >> $f_data_07
		echo "  ethernets:" >> $f_data_07
		echo "    $wan_card:" >> $f_data_07
		echo "      dhcp4: false" >> $f_data_07
		echo "      dhcp6: false" >> $f_data_07
		echo "      addresses: ["${_array[0]}.${_array[1]}"/24]" >> $f_data_07
		echo "      gateway4:" ${_array[5]} >> $f_data_07
		echo "      nameservers:" >> $f_data_07
		echo "        addresses: ["${_array[4]}", 8.8.8.8]" >> $f_data_07

		#echo "# WLAN" >> $f_data_07
		#echo "network:" >> $f_data_07
		#echo "  version: 2" >> $f_data_07
		#echo "  renderer: networkd"
		echo "  wifis:" >> $f_data_07
		echo "    $wlan_card:" >> $f_data_07                    
		echo "      optional: true" >> $f_data_07
		echo "      access-points:" >> $f_data_07
		echo "        \"${_array[6]}\":" >> $f_data_07									
		echo "          password: \"${_array[7]}\"" >> $f_data_07	
		echo "      dhcp4: false" >> $f_data_07
		echo "      dhcp6: false" >> $f_data_07		
		echo "      addresses: ["${_array[0]}.${_array[1]}"/24]" >> $f_data_07	
		echo "      gateway4: "${_array[5]} >> $f_data_07	
		echo "      nameservers:" >> $f_data_07	
		echo "        addresses: ["${_array[4]}", 8.8.8.8]" >> $f_data_07			
		
		
	fi 
	netplan apply 2>/dev/null
}
