#!/bin/bash
#
# netz_install_networkmanager.inc




network_manager_active()
{


    #. var/network_config_parameter_variable

	local art_netz=$1           # dhcp oder fix_ip
	local wan_card="enp"		# praeposition=enp
	local wlan_card="wlp"		# praeposition=wlp
	local _file=""
	local _file1=""
	local _nr=1
	local _variable=""
	local _net=""
	local _line=""
	local _lg=0
	local _i=0
	local _found_value=""
	declare -a _array
	local _index=0

	wan_card=$(sudo lshw -C network 2>/dev/null | grep "enp" )
	wlan_card=$(sudo lshw -C network 2>/dev/null| grep "wlp" )

	wan_card=${wan_card##*: }
	wlan_card=${wlan_card##*: }
    
    ######################################################
    # array aufbau mit netz-informationen
    while read _line
    do
    	_lg=${#_line}
    	
    	for (( _i; $_i<$_lg; _i++ ))
    	do
    		if [[ "${_line:$_i:1}" == "=" ]]
    		then	
    			_found_value=${_line:$((_i+1)):$((_lg-_i))}
    			_array[$_index]="$_found_value"
    			_index=$((_index+1))
    		fi	
    	done	
    	_i=0
	done < $f_data_04 

	global_network_array=("${_array[@]}") # Übergabe der Werte an global_network_array in ! 

    if ([[ "${_array[2]}" != "0" ]] || [[ "${_array[3]}" != "0" ]]) && [[ "${_array[11]}" = "[X]" ]]
    then 
    	# falsche Eingabe
    	return 226			# bis ok!

    else	
    	# #################################################################################################
    	# ethernet - Verbindung
    	# ######################
   		if [[ "$art_netz" = "dhcp" ]] 
		then
			# Anlegen eine Network Datei.
			nmcli con add type ethernet ifname $wan_card  &>/dev/null
			nmcli con mod "ethernet-"$wan_card connection.id "wan_dhcp_ip" &>/dev/null
			nmcli con mod "wan_dhcp_ip" ipv4.method "auto" &>/dev/null
			nmcli con mod "wan_dhcp_ip" ipv6.method "disabled" #&>/dev/null
		    nmcli con mod "wan_dhcp_ip"  ipv6.method "ignore" #&>/dev/null
		else # fix_ip
		    # ip4 Section anpassung
		    nmcli con add type ethernet ifname $wan_card ip4 ${_array[0]}.${_array[1]}/24 gw4 ${_array[5]} &>/dev/null
		    nmcli connection modify "ethernet-"$wan_card connection.id "wan_fix_ip"
		    nmcli con mod "wan_fix_ip" ipv4.dns "${_array[4]} 8.8.8.8" &>/dev/null
		    nmcli con mod "wan_fix_ip" ipv4.method "manual" &>/dev/null
		    nmcli con mod "wan_fix_ip" ipv6.method "disabled" &>/dev/null
		    nmcli con mod "wan_fix_ip" ipv6.method "ignore" &>/dev/null
		    #dummy=""
		fi
		# #################################################################################################
		# wifi - Verbindung
		# ##################
		if [[ "$art_netz" = "dhcp" ]]  
		then
			# Anlegen eine Network Datei.
			nmcli dev wifi con ${_array[6]} password ${_array[7]} &>/dev/null
		    nmcli connection modify ${_array[6]} connection.id "wlan_dhcp_ip" &>/dev/null
		    nmcli con mod "wlan_dhcp_ip" ipv4.method "auto" &>/dev/null
		    nmcli con mod "wlan_dhcp_ip" ipv6.method "disabled" &>/dev/null
		    nmcli con mod "wlan_dhcp_ip" ipv6.method "ignore" &>/dev/null
		    #dummy=""
		else # fix_ip
		    # ip4 Section anpassung
		    nmcli dev wifi connect "${_array[6]}" password ${_array[7]} &>/dev/null
		    nmcli con mod "${_array[6]}" ipv4.addresses ${_array[0]}.${_array[1]}/24 ipv4.gateway ${_array[5]} 
		    nmcli con mod ${_array[6]} ipv4.method "manual" &>/dev/null
		    nmcli con mod ${_array[6]} ipv6.method "disabled" &>/dev/nullnmcli con mod ${_array[6]} ipv4.method "manual" &>/dev/null
		    nmcli con mod ${_array[6]} ipv6.method "ignore" &>/dev/null
		    nmcli con mod "${_array[6]}" ipv4.dns "${_array[4]} 8.8.8.8" &>/dev/null

		    #dummy=""
		fi
		
		sudo service network-manager restart &>/dev/null

    fi
    return 0
}