#!/bin/bash
#
# include:
# question_jn.inc
# 
# ---------------------------------

function question_jn()
{
	local answer=""
	local error_code=$1


	while [[ "$answer" != "j" ]]  && [[ "$answer" != "J" ]]  && [[ "$answer" != "d" ]] && [[ "$answer" != "D" ]] && [[ "$answer" != "e" ]] && [[ "$answer" != "E" ]] 
	do
		get_key
		answer=$KEY_BUFFER
		if [[ "$answer" = "n" ]] || [[ "$answer" = "N" ]] || [[ "$answer" = "f" ]] || [[ "$answer" = "F" ]] || [[ "$answer" = "w" ]]|| [[ "$answer" = "W" ]]
		then
			error_code=$1	
       		return_value=$error_code
       		logging $return_value $funcname
       		if [[ $error_code = "111111" ]]
       		then
       			echo "abbruch!"
       			exit 1
       		fi	
       		return 1
		fi	

	done
	return 0
}

function desicion_answer()
{
	local answer=""
	local desicion_code=$1
	local desicion_alternative=$2
 	local _z=$3
 	local _y=$4
 	local _esc=$5	#Abbruchtaste ESC=27
 	local _help=$6
 	local key_pressed=0

	while true  
	do
		if [[ -z $_help ]]
	 	then
	 	     _help=0
	 	fi    
		if (($_help != 1))
		then	
			pos_x_y $_z $_y
		else
			pos_x_y $_z $((_y + 2 ))
		fi	
		get_key
		key_pressed=$?
		answer=$KEY_BUFFER		# global variable "KEY_BUFFER" über get_key definiert!

		if [[ $key_pressed = $_esc ]] && (( $_help != 1 ))
		then
			return 27
		else
			if (($_help == 1)) && [[ $key_pressed = $_esc ]]
			then	
				answer="n"
			fi	
		fi	
		if [[ ${answer^} = "R" ]]  # uppercase!
		then
			return 2
		fi		
		if (( $_z > 0 )) || (( $_y > 0 ))
		then	
			echo $answer
		fi

		if [[ ${answer^} = ${desicion_code^} ]] 
		then
			# ja,yes		
			return 0
		elif [[ ${answer^} = ${desicion_alternative^} ]] 
		then
			# no
			return 1	
		fi

		KEY_BUFFER=""	
	done
	# rückgabe wert mit $? abfragen!
}


